<script setup lang="ts">
  import type { CmsElementText } from '@shopware-pwa/composables-next';
  import { useCmsElementConfig } from '@shopware-pwa/composables-next';
  import { decodeHTML } from 'entities';
  import { CSSProperties } from 'vue';
  import { renderHtml } from '~/node_modules/@shopware-pwa/cms-base/helpers/html-to-vue/renderToHtml';
  import { getOptionsFromNode } from '~/node_modules/@shopware-pwa/cms-base/helpers/html-to-vue/getOptionsFromNode';

  const props = withDefaults(
    defineProps<{
      content: CmsElementText;
      as?: string;
    }>(),
    {
      as: 'div',
    },
  );

  const context = getCurrentInstance();
  const { getConfigValue } = useCmsElementConfig(props.content);

  const mappedContent = computed<string>(() => {
    return props.content?.data?.content || getConfigValue('content');
  });

  const style = computed<CSSProperties>(() => ({
    justifyContent: getConfigValue('verticalAlign'),
  }));

  const hasVerticalAlignment = computed(() => !!style.value.justifyContent);

  const CmsTextRender = () => {
    const config = {
      container: {
        type: props.as,
      },
      textTransformer: (text: string) => decodeHTML(text),
      extraComponentsMap: {
        link: {
          conditions: (node: any) => {
            return node.type === 'tag' && node.name === 'a' && !node.attrs?.class?.match(/btn\s?/);
          },
          renderer: (node: any, children: any, createElement: any) => {
            return createElement(
              'a',
              {
                class: 'underline text-base font-normal text-brand-primary hover:text-gray-900',
                ...getOptionsFromNode(node).attrs,
              },
              [...children],
            );
          },
        },
        button: {
          conditions: (node: any) => {
            return node.type === 'tag' && node.name === 'a' && node.attrs?.class?.match(/btn\s?/);
          },
          renderer: (node: any, children: any, createElement: any) => {
            const btnClass =
              'rounded-md inline-block my-2 py-2 px-4 border border-transparent text-sm font-medium focus:outline-none disabled:opacity-75';
            const _class = node?.attrs?.class
              .replace('btn-secondary', `${btnClass} bg-brand-dark text-white`)
              .replace('btn-primary', `${btnClass} bg-brand-primary text-white`);

            return createElement(
              'a',
              {
                class: _class,
                ...getOptionsFromNode(node).attrs,
              },
              [...children],
            );
          },
        },
      },
    };
    const rawHtml = mappedContent.value?.length > 0 ? mappedContent.value : '<div></div>';
    return renderHtml(rawHtml, config, h, context);
  };
</script>
<template>
  <div :class="{ 'flex h-full flex-col': hasVerticalAlignment }" :style="style">
    <CmsTextRender />
  </div>
</template>
<style>
  *[name='cms-element-text'] hr {
    @apply max-w-40 border-border mx-auto my-4 border;
  }
</style>
